/*******************************************************************************

    TERMOMETRO COM PIC 16F676/ LM35/ 3 DISPLAYS DE 7 SEGUIMENTOS

    AUTOR: CLAUDIO LRIOS

    DATA: 27/08/2015


    USE CCS C COMPILER.
    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
    USO DIDTICO APENAS.
*******************************************************************************/


  #define ANODO_COMUM

//Descomente para anodo comum  e comente para catodo comum
//==============================================================================

 //  #define PERDI_BYTE_CALIBRACAO    //coloca um valor para oscall

   //descomente em caso de apagar acidentalmente o byte de calibrao
//==============================================================================

#include <16F676.h>
#device adc=10
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOPROTECT, BROWNOUT, MCLR, NOCPD, PUT

#ifdef  PERDI_BYTE_CALIBRACAO  // calibrao do oscilador interno do pic
#ROM  0X3FF = {0X34FC}//mxima freq= 0x34fc ;mdia=0x3480; minima=0x3400
#endif


#byte PORTA      = 5
#byte PORTC      = 7
#byte TRISA      = 0x85
#byte TRISC      = 0x87
#byte ADRESH     = 0x1e
#byte ADRESL     = 0x9e
#byte ANSEL      = 0x91
#byte ADCON0     = 0x1f
#byte ADCON1     = 0X9F
#byte CMCON      = 0X19
#byte OPTION_REG = 0X81

#bit   k0       = 0x5.5  //catodo/anodo 0  pino 2
#bit   k1       = 0x5.2  //catodo/anodo 1  pino 11
#bit   g_seg    = 0x5.4  //seguimento 'g' pino 3
#bit   ADON     = 0X1F.0 //on/off conversor A/D
#bit   GO_DONE  = 0X1F.1 //inicia converso A/D
#bit   T0IF     = 0X8B.2 //flag de over flow do timer 0

#define fator  100    // 0,0010 volt por unidade convertida
#define N_AMOSTRA  1024 //1024 amostras por apresentao
int1 f_ok;
int8 vez,dig0,dig1,dig0a,dig1a;
int16 conv,cnt;
int32 RES;
//constantes para converso 7 seguimentos

//                         PGFEDCBA   SEGUIMENTOS
//                   PORTB 76543210
int8 const num[] = {     0B00111111,//0
                         0B00000110,//1
                         0B01011011,//2
                         0B01001111,//3
                         0B01100110,//4
                         0B01101101,//5
                         0B01111101,//6
                         0B00000111,//7
                         0B01111111,//8
                         0B01101111 //9
                                        };



 void  multiplexa(){
    int8 a;
    if(f_ok) {dig0=dig0a; dig1=dig1a; f_ok=0;}
   //  if(!T0IF) return; //utiliza o timer 0 para temporizar cada digito
  //   T0IF=0;
     if(++vez>1)vez=0;
     PORTA=0;//desliga display

   switch (vez){
     case 0:{
       a= num[dig0];
       #ifdef ANODO_COMUM
        if(a&0x40) g_seg=0; else g_seg=1;//acende 'g'
        PORTC=~a;
       #else
       if(a&0x40) g_seg=1; else g_seg=0;//acende 'g'
        PORTC=a;
       #endif
        k0=1;//liga display 'unidade'
       break;

     }//case 0:

      case 1:{
       a= num[dig1];
       #ifdef ANODO_COMUM
        if(a&0x40) g_seg=0; else g_seg=1;//acende 'g'
        PORTC=~a;
       #else
       if(a&0x40) g_seg=1; else g_seg=0;//acende 'g'
        PORTC=a;
       #endif
       k1=1;//liga display 'dezena'
       break;
     }//case 1:
  }//switch (vez)

   delay_ms(2);
 } //void  multiplexa()





 void le_lm35(){

  if(GO_DONE) return; //utiliza o timer 0 para temporizar numero de comverso
  if(!RES){
   
   RES=(int32)ADRESH<<8;
   RES+=(int32)ADRESL; //obtem valor INICIAL
   GO_DONE=1; //inicia nova converso
   return;
  }
      
   RES+=(int32)ADRESH<<8;
   RES+=(int32)ADRESL; //obtem valor

   if(++cnt<N_AMOSTRA){
    GO_DONE=1; //inicia nova converso
    return;
   }

  // RES=RES/N_AMOSTRA;
   conv=RES/N_AMOSTRA;
   
   
   cnt=1;
  // conv=(RES*fator)/100; //calcula resultado para apresentao no display
   
   dig1a= conv /100;//digito das centenas
   dig0a= (conv %100) /10;//digito das dezenas
   
   f_ok=1;
   RES=0;
   GO_DONE=1; //inicia nova converso


 }

/*******************************************************************************
                            ROTINA MAIN
*******************************************************************************/


void main() {
   OPTION_REG=0; //sem prescaller
   ADCON0=0b11000000; //just.direita/canal 0/ vref=VREF
   ADCON1=0X60; //frequencia para oscilador interno
   ANSEL=1;// canal 0 para o AD
   CMCON= 7;//desliga comparadores internos
   PORTA=0;//desliga display
   TRISA= 0b00000011;//tudo saida exceto ra3 e ra0(ad) ra1=vref
   TRISC=0;//tudo saida
   dig0=0;
   dig1=0;
   cnt=0;
   RES=0;
   ADON=1; //liga a/d
/*******************************************************************************
                     LAO PRINCIPAL DE REPETIO
*******************************************************************************/

   for(;;){

  le_lm35();//le a tenso gerada pelo LM35
  
    
   
   multiplexa();//apresentao nos displays

   }
}
